"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


AerodromeSlipstreamSellExactlyRequestAmountInTypedDict = TypeAliasType(
    "AerodromeSlipstreamSellExactlyRequestAmountInTypedDict", Union[float, str]
)
r"""The amount of the token to swap from"""


AerodromeSlipstreamSellExactlyRequestAmountIn = TypeAliasType(
    "AerodromeSlipstreamSellExactlyRequestAmountIn", Union[float, str]
)
r"""The amount of the token to swap from"""


AerodromeSlipstreamSellExactlyRequestAmountOutMinimumTypedDict = TypeAliasType(
    "AerodromeSlipstreamSellExactlyRequestAmountOutMinimumTypedDict", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


AerodromeSlipstreamSellExactlyRequestAmountOutMinimum = TypeAliasType(
    "AerodromeSlipstreamSellExactlyRequestAmountOutMinimum", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


class AerodromeSlipstreamSellExactlyRequestTypedDict(TypedDict):
    r"""Request model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    tick_spacing: int
    r"""The tick spacing of the pool"""
    amount_in: AerodromeSlipstreamSellExactlyRequestAmountInTypedDict
    r"""The amount of the token to swap from"""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    amount_out_minimum: NotRequired[
        AerodromeSlipstreamSellExactlyRequestAmountOutMinimumTypedDict
    ]
    r"""The minimum amount of the token to swap to, defaults to 0"""


class AerodromeSlipstreamSellExactlyRequest(BaseModel):
    r"""Request model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    tick_spacing: int
    r"""The tick spacing of the pool"""

    amount_in: AerodromeSlipstreamSellExactlyRequestAmountIn
    r"""The amount of the token to swap from"""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    amount_out_minimum: Optional[
        AerodromeSlipstreamSellExactlyRequestAmountOutMinimum
    ] = None
    r"""The minimum amount of the token to swap to, defaults to 0"""
