"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from enum import Enum
from typing import Union
from typing_extensions import TypeAliasType, TypedDict


class IncreaseAllowanceParamsContractName(str, Enum):
    r"""The name of the contract to increase allowance for."""

    AAVE_V3_POOL = "AaveV3Pool"
    AERODROME_BASIC_ROUTER = "AerodromeBasicRouter"
    AERODROME_SLIPSTREAM_ROUTER = "AerodromeSlipstreamRouter"
    AERODROME_SLIPSTREAM_NONFUNGIBLE_POSITION_MANAGER = (
        "AerodromeSlipstreamNonfungiblePositionManager"
    )
    UNISWAP_V3_ROUTER = "UniswapV3Router"
    UNISWAP_V3_NFT_POSITION_MANAGER = "UniswapV3NFTPositionManager"
    MORPHO = "Morpho"
    SKY_DAI_USDS_CONVERTER = "SkyDaiUsdsConverter"
    SKY_USDC_USDS_CONVERTER = "SkyUsdcUsdsConverter"
    SKY_USDS_VAULT = "SkyUsdsVault"


IncreaseAllowanceParamsAmountTypedDict = TypeAliasType(
    "IncreaseAllowanceParamsAmountTypedDict", Union[float, str]
)
r"""The amount of tokens to increase the allowance by."""


IncreaseAllowanceParamsAmount = TypeAliasType(
    "IncreaseAllowanceParamsAmount", Union[float, str]
)
r"""The amount of tokens to increase the allowance by."""


class IncreaseAllowanceParamsTypedDict(TypedDict):
    r"""Parameters model for increasing token allowance for a contract."""

    token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    contract_name: IncreaseAllowanceParamsContractName
    r"""The name of the contract to increase allowance for."""
    amount: IncreaseAllowanceParamsAmountTypedDict
    r"""The amount of tokens to increase the allowance by."""


class IncreaseAllowanceParams(BaseModel):
    r"""Parameters model for increasing token allowance for a contract."""

    token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    contract_name: IncreaseAllowanceParamsContractName
    r"""The name of the contract to increase allowance for."""

    amount: IncreaseAllowanceParamsAmount
    r"""The amount of tokens to increase the allowance by."""
